/*
 * ##################################################### Start LightConfigurationPage #####################################################
 */

function LightConfigurationPage() {
  if (!(this instanceof LightConfigurationPage)) {
    return new LightConfigurationPage();
  }
  PageTemplate.call(this);
  var thisClass = this;
  this.currentLightMapping = undefined;
  this.availableBridges = undefined;

  this.switchOnBrightnessIncrement = 5;
  this.maxBridges = 5;
  this.registeredBridges = [];
  this.lightConfigurationChanged = false;

  this.divHueDeviceStatus = undefined;
  this.divHueAppStatus = undefined;
  this.divHueLightMapping = undefined;
  this.configTable = undefined;

  this.prepare = function() {
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      thisClass.hueLightMapping();
      thisClass.noEtsProjectPage();
      thisClass.wrongAppStatePage();
      thisClass.showPageContent(thisClass.divHueLightMapping);
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
  };

  this.showPageContent = function(pageContent) {
    if (pageContent != thisClass.divHueLightMapping) {
      if (thisClass.contentSection.contains(thisClass.divHueLightMapping)) {
        thisClass.contentSection.removeChild(thisClass.divHueLightMapping);
      }
      if (pageContent == thisClass.divHueDeviceStatus) {
        if (!thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
          if (thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
            thisClass.contentSection.removeChild(thisClass.divHueAppStatus);
          }
          thisClass.contentSection.appendChild(thisClass.divHueDeviceStatus);
        }
      } else {
        if (!thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
          if (thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
            thisClass.contentSection.removeChild(thisClass.divHueDeviceStatus);
          }
          thisClass.contentSection.appendChild(thisClass.divHueAppStatus);
        }
      }
    } else {
      if (!thisClass.contentSection.contains(thisClass.divHueLightMapping)) {
        if (thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
          thisClass.contentSection.removeChild(thisClass.divHueAppStatus);
        }
        if (thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
          thisClass.contentSection.removeChild(thisClass.divHueDeviceStatus);
        }
        thisClass.contentSection.appendChild(thisClass.divHueLightMapping);
      //        thisClass.requestBridgesWithLights();
      }
    }
  }

  this.hueLightMapping = function() {
    if (!thisClass.divHueLightMapping) {
      thisClass.divHueLightMapping = document.createElement('div');

      var headerHueBridgesConfig = document.createElement('h3');
      headerHueBridgesConfig.setAttribute('class', 'h3');
      headerHueBridgesConfig.appendChild(document.createTextNode(i18n.translate('registered_bridge_title')));
      thisClass.divHueLightMapping.appendChild(headerHueBridgesConfig);

      var bridges = document.createElement('div');
      bridges.setAttribute('class', 'iseGrid');
      bridges.setAttribute('id', 'registeredBridges');
      thisClass.divHueLightMapping.appendChild(bridges);

      var addButton = createGlyphIconButton('plus', 'white');
      addButton.onclick = thisClass.addBridge;
      addButton.appendChild(document.createTextNode(i18n.translate('add_hue_bridge')));
      addButton.setAttribute('id', 'addBridge');
      thisClass.divHueLightMapping.appendChild(addButton);

      thisClass.dataBindings.push(function() {
        if (thisClass.registeredBridges && thisClass.availableBridges) {
          while (bridges.hasChildNodes()) {
            bridges.removeChild(bridges.childNodes[0]);
          }
          var divRow = document.createElement('div');
          var spanColumn = document.createElement('span');
          var divHint = document.createElement('div');
          divHint.setAttribute('class', 'text_hint');
          divHint.appendChild(document.createTextNode(i18n.translate('hue_bridgeconfig_hint')));
          spanColumn.appendChild(divHint);
          divRow.appendChild(spanColumn);
          bridges.appendChild(divRow);
          for (var i = 0; i < thisClass.registeredBridges.length; i++) {
            if (i > thisClass.maxBridges) break;
            thisClass.addBridgeColumn(thisClass.registeredBridges[i], bridges);
          }
          if (thisClass.registeredBridges.length >= thisClass.maxBridges) {
            addButton.setAttribute('disabled', true);
          } else {
            addButton.removeAttribute('disabled');
          }
        }
      });

      var headerHueLightingConfig = document.createElement('h3');
      headerHueLightingConfig.setAttribute('class', 'h3');
      headerHueLightingConfig.appendChild(document.createTextNode(i18n.translate('config_title_text')));
      thisClass.divHueLightMapping.appendChild(headerHueLightingConfig);
      var spanHueLightingConfigHint = document.createElement('div');
      spanHueLightingConfigHint.setAttribute('class', 'text_hint');
      spanHueLightingConfigHint.appendChild(document.createTextNode(i18n.translate('ets_setting_additional_hint')));
      thisClass.divHueLightMapping.appendChild(spanHueLightingConfigHint);

      var divHueLightingConfigTable = document.createElement('div');
      divHueLightingConfigTable.setAttribute('id', 'lightmapping_wrapper');
      divHueLightingConfigTable.setAttribute('class', 'dataTables_wrapper no-footer');
      divHueLightingConfigTable.setAttribute('style', 'width: 100%');
      thisClass.configTable = document.createElement('table');
      thisClass.configTable.setAttribute('id', 'lightmapping');
      thisClass.configTable.setAttribute('class', 'table--hoverRow table--borderHorizontal');
      var thead = document.createElement('thead');

      var tr = document.createElement('tr');
      var th1 = document.createElement('th');
      th1.appendChild(document.createTextNode(i18n.translate('number')));
      var th2 = document.createElement('th');
      th2.appendChild(document.createTextNode(i18n.translate('light')));
      var th3 = document.createElement('th');
      th3.appendChild(document.createTextNode(i18n.translate('rgb_conversion')));
      var th4 = document.createElement('th');
      th4.appendChild(document.createTextNode(i18n.translate('switch_on_brightness')));
      var th5 = document.createElement('th');
      th5.appendChild(document.createTextNode(i18n.translate('dimming_mode_selection')));
      tr.appendChild(th1);
      tr.appendChild(th2);
      tr.appendChild(th3);
      tr.appendChild(th4);
      tr.appendChild(th5);
      thead.appendChild(tr);

      thisClass.configTable.appendChild(thead)
      var tbody = document.createElement('tbody');
      thisClass.configTable.appendChild(tbody)

      thisClass.divHueLightMapping.appendChild(thisClass.configTable);

      thisClass.dataBindings.push(function() {
        if (thisClass.currentLightMapping && mainSite.currentModalDialog == undefined) {
          thisClass.updateMappingTable();
        }
      });

      var ulButtons = document.createElement('ul');
      ulButtons.setAttribute('class', 'buttonlist')
      var clearButton = document.createElement('button');
      clearButton.setAttribute('class', 'button--xsm');
      clearButton.appendChild(document.createTextNode(i18n.translate('clear')));
      var liClearButton = document.createElement('li');
      liClearButton.appendChild(clearButton);
      ulButtons.appendChild(liClearButton);
      var saveButton = document.createElement('button');
      saveButton.setAttribute('class', 'button--xsm');
      saveButton.setAttribute('disabled', 'true');
      thisClass.lightConfigurationChanged = false;
      saveButton.appendChild(document.createTextNode(i18n.translate('save')));
      saveButton.onclick = thisClass.saveMapping;
      var liSaveButton = document.createElement('li');
      liSaveButton.appendChild(saveButton);
      ulButtons.appendChild(liSaveButton);
      thisClass.divHueLightMapping.appendChild(ulButtons);

      thisClass.enableSaveButton = function() {
        saveButton.removeAttribute('disabled');
      }

      thisClass.clearConfiguration = function() {
        thisClass.currentLightMapping.lightmappings = [];
        // If the user wants to clear the list and send the (empty) result => Clear list in the HueApp, we need to set 'changed' to true:
        var tabledata = $(thisClass.configTable).DataTable();
        for (var i = 0; i < tabledata.data().length; i++) {
          tabledata.row(i).data(new LightMapping({
            'number': i,
            'changed': true
          }));
          tabledata.row(i).draw();
        }
        thisClass.lightConfigurationChanged = true;
        saveButton.removeAttribute('disabled');
      };

      clearButton.onclick = thisClass.clearConfiguration;

      thisClass.setChanged = function(value, redraw) {
        redraw = redraw || true;
        var tabledata = $(thisClass.configTable).DataTable();
        for (var i = 0; i < tabledata.data().length; i++) {
          tabledata.row(i).data().changed = value;
        }
        thisClass.lightConfigurationChanged = value;
        tabledata.draw(redraw);
        // enable/disable save button:
        if (value) {
          saveButton.removeAttribute('disabled');
        } else {
          saveButton.setAttribute('disabled', 'true');
        }
      }

      thisClass.dataBindings.push(function() {
        if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload == true && mainSite.appState && mainSite.appState.state == 'Running') {
          thisClass.showPageContent(thisClass.divHueLightMapping);
        }
      });
    }
  }

  this.enableSaveButton = undefined;

  this.noEtsProjectPage = function() {
    if (!thisClass.divHueDeviceStatus) {
      thisClass.divHueDeviceStatus = document.createElement('div');
      var headerHueDeviceStatus = document.createElement('h3');
      headerHueDeviceStatus.setAttribute('class', 'h3');
      headerHueDeviceStatus.appendChild(document.createTextNode(i18n.translate('error_title_NoEtsProject')));
      var pHueDeviceStatus = document.createElement('p');
      var device_status = document.createTextNode(i18n.translate('error_text_NoEtsProject'));
      pHueDeviceStatus.appendChild(device_status);
      thisClass.divHueDeviceStatus.appendChild(headerHueDeviceStatus);
      thisClass.divHueDeviceStatus.appendChild(pHueDeviceStatus);
      thisClass.divHueDeviceStatus.appendChild(document.createElement('br'));
      thisClass.dataBindings.push(function() {
        if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload == false) {
          thisClass.showPageContent(thisClass.divHueDeviceStatus);
        }
      });
    }
  }

  this.addBridge = function() {
    var dialog = new ModalAddBridgeDialog(thisClass);
    dialog.prepare();
    dialog.setCallbackFunction(function(ident) {
      if (ident === '') {
        console.log('Add bridge: registration canceled!');
      } else {
        console.log('Add bridge: registration successful for bridge with ident: ' + ident);
        setTimeout(mainSite.timer.getBridgeInfo.oneShot, INTERVAL.FIVEHUNDREDMILLIS);
      }
    });
    dialog.show();
  }

  this.addBridgeColumn = function(bridge, parent) {
    var bridgeColumn = document.createElement('div');
    bridgeColumn.setAttribute('id', bridge.ident);
    var content = document.createElement('p');
    content.setAttribute('class', 'label');
    var title = document.createElement('span');
    var titleText = document.createElement('b');
    title.appendChild(titleText);
    var name;
    var status = document.createElement('span');
    var statusText;
    var optionalStatusButton = undefined;

    if (bridge.name === undefined) {
      // we have no name, only ident => bridge is not connected/found
      bridge.name = i18n.translate('philips_hue_bridge') + ' (' + bridge.ident + ')';
    }
    if (bridge.serial) {
      title.appendChild(document.createTextNode(', ID: ' + bridge.serial.substring(6)));
    }
    var ipformat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
    var bridgeRegisteredViaIPOrSerialText = (' - ') + i18n.translate('bridge_registered_via') + ' ';
    if (bridge.ident.match(ipformat)) {
      bridgeRegisteredViaIPOrSerialText += i18n.translate('static_ip');
    } else if (bridge.ident == bridge.serial) {
      bridgeRegisteredViaIPOrSerialText += i18n.translate('id');
    }
    title.appendChild(document.createTextNode(bridgeRegisteredViaIPOrSerialText));
    name = bridge.name;
    statusText = document.createTextNode(i18n.translate('status_title') + ': ' + i18n.translate(bridge.error_code));
    if (bridge.error_code == 'bridge_error_0') {
      status.removeAttribute('style');
    } else if (bridge.error_code == 'bridge_error_4') {
      optionalStatusButton = document.createElement('button');
      optionalStatusButton.appendChild(document.createTextNode(decodeURI('\uE051')));
      var bridge2 = bridge;
      optionalStatusButton.onclick = function() {
        var dialog = new ModalConfirmDialogOkCancel(i18n.translate('register_app') + " - " + name, i18n.translate('status_need_registration'), i18n.translate('register'));
        dialog.prepare();
        dialog.setCallbackFunction(function(result) {
          if (result) {
            var websocket = CreateWebSocket();
            websocket.onopen = function(evt) {
              var lightMappingSocket = new LightMappingSocket(websocket);
              lightMappingSocket.invoke_bridge_registration(bridge2, function(response) {
                if (response.response == "io_error") {
                  CreateErrorDialog(i18n.translate('io_error'));
                }
                thisClass.requestBridgesWithLights();
              });
            };
          }
        });
        dialog.show();
      }
    } else {
      if (bridge.error_code == 'bridge_error_1') {
        status.setAttribute('style', 'color:red; font-weight: bold;');
      } else {
        status.setAttribute('style', 'color:darkorange; font-weight: bold;');
      }
      optionalStatusButton = document.createElement('button');
      optionalStatusButton.appendChild(document.createTextNode(decodeURI('\uE197')));
      var bridge2 = bridge;
      optionalStatusButton.onclick = function() {
        var ipformat = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
        var bridgeRegisteredViaIPOrSerialText = (' ') + i18n.translate('bridge_registered_via') + ' ';
        if (bridge.ident.match(ipformat)) {
          bridgeRegisteredViaIPOrSerialText += i18n.translate('static_ip') + ' ' + bridge.ip;
        } else if (bridge.ident == bridge.serial) {
          bridgeRegisteredViaIPOrSerialText += i18n.translate('id') + ' ' + bridge.serial.substring(6);
        }
        var dialog = new ModalConfirmDialogOk(i18n.translate('something_wrong'), i18n.translate(bridge.error_code + '_help').replace(/HUEBRIDGEINFORMATION/gi,
          function(subst) {
            switch (subst) {
              case 'HUEBRIDGEINFORMATION':
                return bridgeRegisteredViaIPOrSerialText;
            }
          }));
        dialog.prepare();
        dialog.show();
      }
    }
    titleText.appendChild(document.createTextNode(name));
    status.appendChild(statusText);

    var buttonRemove = document.createElement('button');
    buttonRemove.appendChild(document.createTextNode(decodeURI('\uE208')));
    var bridge2 = bridge;
    buttonRemove.onclick = function() {
      var dialog = new ModalConfirmDialogOkCancel(i18n.translate('remove_hue_bridge') + " - " + name, i18n.translate('remove_bridge_info'));
      dialog.prepare();
      dialog.setCallbackFunction(function(result) {
        if (result) {
          var websocket = CreateWebSocket();
          websocket.onopen = function(evt) {
            var lightMappingSocket = new LightMappingSocket(websocket);
            lightMappingSocket.invoke_bridge_deregistration(bridge2, function(response) {
              thisClass.requestBridgesWithLights();
              setTimeout(mainSite.timer.getBridgeInfo.oneShot, INTERVAL.FIVEHUNDREDMILLIS);
            });
          };
        }
      });
      dialog.show();
    }
    content.appendChild(title);
    content.appendChild(buttonRemove);
    content.appendChild(document.createElement('br'));
    content.appendChild(status);
    if (optionalStatusButton) {
      content.appendChild(optionalStatusButton);
    }
    bridgeColumn.appendChild(content);
    parent.appendChild(bridgeColumn);
  }

  this.getBridgeInfo = function(ident) {
    for (var i = 0; i < thisClass.registeredBridges.length; i++) {
      if (ident == thisClass.registeredBridges[i].ident) {
        if (thisClass.registeredBridges[i].name === undefined) {
          // we have no name, only ident => bridge is not connected/found
          thisClass.registeredBridges[i].name = i18n.translate('philips_hue_bridge') + ' (' + thisClass.registeredBridges[i].ident + ')';
        }
        return thisClass.registeredBridges[i];
      }
    }
    for (var i = 0; i < thisClass.availableBridges.bridges.length; i++) {
      if (ident == thisClass.availableBridges.bridges[i].serial || ident == thisClass.availableBridges.bridges[i].ip) {
        thisClass.availableBridges.bridges[i].ident = ident;
        return thisClass.availableBridges.bridges[i];
      }
    }
    var bridge = new Bridge;
    bridge.ident = ident;
    return bridge;
  }

  this.updateBridgeInfo = function() {
    // update the model
    thisClass.registeredBridges = [];

    if (thisClass.currentLightMapping && thisClass.currentLightMapping.registered_bridges) {
      for (var i = 0; i < thisClass.availableBridges.bridges.length; i++) {
        for (var j = 0; j < thisClass.currentLightMapping.registered_bridges.length; j++) {
          if (thisClass.availableBridges.bridges[i].serial == thisClass.currentLightMapping.registered_bridges[j].ident || thisClass.availableBridges.bridges[i].ip == thisClass.currentLightMapping.registered_bridges[j].ident) {
            thisClass.availableBridges.bridges[i].ident = thisClass.currentLightMapping.registered_bridges[j].ident;
            thisClass.availableBridges.bridges[i].registered = true;
          }
        }
      }
      thisClass.registeredBridges = thisClass.currentLightMapping.registered_bridges;
    }
  }

  this.requestLightsAndMappings = function(callback) {
    var websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.getBridgeAndLightMapping(function(response) {
        if (response.response == 'bridge_and_light_mappings') {
          thisClass.currentLightMapping = response;
          thisClass.updateBridgeInfo();
          thisClass.updateLightSelectOptions();
          if (callback) {
            callback();
          }
          websocket.close();
        }
      });
    };
    websocket.onerror = function(evt) {
      thisClass.currentLightMapping = undefined;
    };
  }
  this.requestBridgesWithLights = function(callback) {
    var websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.getBridgesWithLights(function(response) {
        if (response.response == 'bridges_with_lights') {
          thisClass.availableBridges = response;
          thisClass.requestLightsAndMappings(callback);
          websocket.close();
        }
      });
    };
    websocket.onerror = function(evt) {
      thisClass.availableBridges = undefined;
    };
  }

  this.wrongAppStatePage = function() {
    if (!thisClass.divHueAppStatus) {
      thisClass.divHueAppStatus = document.createElement('div');
      var headerHueAppStatus = document.createElement('h3');
      headerHueAppStatus.setAttribute('class', 'h3');
      headerHueAppStatus.appendChild(document.createTextNode(i18n.translate('error_title_WrongAppState')));
      var pHueAppStatus = document.createElement('p');
      var hue_status = document.createTextNode(i18n.translate('error_text_WrongAppState_na'));
      pHueAppStatus.appendChild(hue_status);
      thisClass.divHueAppStatus.appendChild(headerHueAppStatus);
      thisClass.divHueAppStatus.appendChild(pHueAppStatus);
      thisClass.divHueAppStatus.appendChild(document.createElement('br'));

      thisClass.dataBindings.push(function() {
        if (mainSite.appState && mainSite.appState.state != 'Running' && mainSite.deviceInfo.EtsDownload == true) {
          switch (mainSite.appState.state) {
            case 'Stopped':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_0');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            case 'Starting':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_1');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            case 'Stopping':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_3');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            default:
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_na');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
          }
        } else if (!mainSite.appState && mainSite.deviceInfo.EtsDownload == true) {
          hue_status.nodeValue = i18n.translate('error_text_WrongAppState_na');
          thisClass.showPageContent(thisClass.divHueAppStatus);
        }
      });

    }
  }

  this.BootingPage = function() {
    if (!thisClass.divHueBootingPage) {
      thisClass.divHueBootingPage = document.createElement('div');
      var headerHueBootingPage = document.createElement('h3');
      headerHueBootingPage.setAttribute('class', 'h3');
      headerHueBootingPage.appendChild(document.createTextNode(i18n.translate('error_title_Booting')));
      var pHueBootingPage = document.createElement('p');
      var device_BootingPage = document.createTextNode(i18n.translate('error_text_Booting'));
      pHueBootingPage.appendChild(device_status);
      thisClass.divHueBootingPage.appendChild(headerHueBootingPage);
      thisClass.divHueBootingPage.appendChild(pHueBootingPage);
      thisClass.divHueBootingPage.appendChild(document.createElement('br'));
    }
  }

  this.setFocus = undefined;

  // Initialize/update the light configuration table content
  this.updateMappingTable = function() {
    if (thisClass.lightConfigurationChanged) {
      return;
    }
    var configurationTable;
    // get table api reference:
    if ($.fn.dataTable.isDataTable(thisClass.configTable)) {
      // table already initialized
      // get instance
      configurationTable = $(thisClass.configTable).DataTable();
    } else {
      // table not initialized
      if (!thisClass.contentSection.contains(thisClass.divHueLightMapping)) {
        setTimeout(thisClass.updateMappingTable, 200);
        return;
      }
      configurationTable = $(thisClass.configTable).DataTable({
        'paging': false,
        'ordering': false,
        'bFilter': false,
        'info': false,
        'language': i18n.msgDatatablesStore,
        'columns': [{
          data: 'number',
          'width': '3%'
        }, {
          data: 'light',
          'width': '25%'
        }, {
          data: 'rgb_conversion',
          'width': '7%'
        }, {
          data: 'switch_on_brightness',
          'width': '5%'
        }, {
          data: 'dimming_mode_selection',
          'width': '5%'
        }, {
          data: 'changed',
          'width': '3%'
        }
        ],
        'fnRowCallback': function(nRow, aData, iDisplayIndex, iDisplayIndexFull) {
          // Add the source selection:
          var cell1 = nRow.cells[1];
          thisClass.createLightSelect(aData, cell1);
          var cell2 = nRow.cells[2];
          thisClass.createRgbConversion(aData, cell2);
          var cell3 = nRow.cells[3];
          thisClass.createLightSwitchOnBrightness(aData, cell3);
          var cell4 = nRow.cells[4];
          thisClass.createDimmingModeSelection(aData, cell4);
          if (aData['changed'] == true) {
            $('td', nRow).css('background-color', 'LightYellow');
          } else {
            $('td', nRow).css('background-color', 'White');
          }
        },
        'aoColumnDefs': [{
          'visible': false,
          'aTargets': [5]
        }
        ]
      });

      $(thisClass.configTable.tBodies[0]).on('click', 'tr', function() {
        if ($(this).hasClass('selected')) {
          $(this).removeClass('selected');
        } else {
          configurationTable.$('tr.selected').removeClass('selected');
          $(this).addClass('selected');
          // Ok current row has been selected, call another function:
          var aData = $(thisClass.configTable).dataTable().fnGetData(this); // get datarow
          if (null != aData) // null if we clicked on title row
          {
            thisClass.currentRowData = aData;
          }
        }
      });
    }

    // now add new/updated rows:
    var obj = thisClass.currentLightMapping;

    // Check if the datatable is already configured with the correct number of lights
    if (obj.lightmappings.length != configurationTable.rows().data().length) {
      // clear possible old data, e.g. in case of a reprojected device.
      configurationTable.clear();
      // We count the indice j from 1 to the maximum number of lights configured via KNX.
      for (var j = 0; j < thisClass.currentLightMapping.configured_lights; j++) {
        configurationTable.row.add(new LightMapping({
          'number': j
        }));
      }
    }

    // Update the light data row-by-row but only, if the current row has not been changed by the user (changed == false) 
    for (var i = 0; i < obj.lightmappings.length; i++) {
      // This should prevent a crash (=> an empty map), if a saved light has a non ETS configured number!
      var index = parseInt(obj.lightmappings[i]['number']);
      if (index < thisClass.currentLightMapping.configured_lights && !configurationTable.row(index).data()['changed']) {
        configurationTable.row(index).data(new LightMapping(obj.lightmappings[i]));
        // we draw on a per row base, so seems to prevent a full page redraw
        configurationTable.row(index).draw();
      }
    }
    // If obj.lightmappings_persisted == false, the mappings are the default one AND not saved on the device, so flag as changed.
    if (obj.lightmappings_persisted == false) {
      thisClass.enableSaveButton();
    }
  }

  this.lightSelectOptions = [];
  this.updateLightSelectOptions = function() {
    thisClass.lightSelectOptions = [];
    thisClass.lightSelectOptions.map = {};
    thisClass.lightSelectOptions.push({
      'value': '',
      'text': ''
    });
    for (var i = 0; i < thisClass.availableBridges.bridges.length; i++) {
      if (thisClass.availableBridges.bridges[i]) {
        for (var j = 0; j < thisClass.availableBridges.bridges[i].lights.length; j++) {
          var optionLights = {
            'value': 'b' + thisClass.availableBridges.bridges[i].ident + 'l' + thisClass.availableBridges.bridges[i].lights[j].name,
            'text': thisClass.availableBridges.bridges[i].lights[j].name + ' - ' + thisClass.availableBridges.bridges[i].name
          };
          thisClass.lightSelectOptions.map[optionLights.value] = {
            'light': thisClass.availableBridges.bridges[i].lights[j].name,
            'bridge': thisClass.availableBridges.bridges[i].ident
          };
          thisClass.lightSelectOptions.push(optionLights);
        }
      }
    }
    for (var i = 0; i < thisClass.currentLightMapping.lightmappings.length; i++) {
      if (thisClass.currentLightMapping.lightmappings[i].bridge_ident) {
        var optionLights = {
          'value': 'b' + thisClass.currentLightMapping.lightmappings[i].bridge_ident + 'l' + thisClass.currentLightMapping.lightmappings[i].name,
          'text': thisClass.currentLightMapping.lightmappings[i].name + ' - ' + thisClass.getBridgeInfo(thisClass.currentLightMapping.lightmappings[i].bridge_ident).name
        };
        if (!thisClass.lightSelectOptions.map[optionLights.value]) {
          thisClass.lightSelectOptions.map[optionLights.value] = {
            'light': thisClass.currentLightMapping.lightmappings[i].name,
            'bridge': thisClass.currentLightMapping.lightmappings[i].bridge_ident
          };  thisClass.lightSelectOptions.push(optionLights);
        }
      }
    }
  }

  // Init function for Datatables, called to create a light source datalist in the cell described by aData.
  this.createLightSelect = function(aData, parent) {
    while (parent.hasChildNodes()) {
      parent.removeChild(parent.firstChild);
    }
    var selectLight;
    selectLight = document.createElement('select');
    selectLight.setAttribute('name', 'light');
    selectLight.addEventListener('change', function(evt) {
      thisClass.lightChanged(thisClass.lightSelectOptions.map[this.options[this.options.selectedIndex].value], aData);
    });
    selectLight.onkeyup = thisClass.enableSaveButton;
    if (thisClass.lightSelectOptions.length == 0) {
      thisClass.updateLightSelectOptions();
    }

    var eventFunction = function(evt) {
      while (selectLight.hasChildNodes()) {
        selectLight.removeChild(selectLight.firstChild);
      }
      // unselected option
      for (var i = 0; i < thisClass.lightSelectOptions.length; i++) {
        var optionLights = document.createElement('option');
        optionLights.value = thisClass.lightSelectOptions[i].value;
        optionLights.appendChild(document.createTextNode(thisClass.lightSelectOptions[i].text));
        if ('b' + aData.bridge + 'l' + aData.light == thisClass.lightSelectOptions[i].value) {
          optionLights.setAttribute('selected', '');
        }
        selectLight.appendChild(optionLights);
      }
    }
    eventFunction();
    selectLight.addEventListener('change', eventFunction);
    parent.appendChild(selectLight);
  }

  // Init function for Datatables, called to create a rgb_conversion selector in the cell described by aData.
  this.createRgbConversion = function(aData, parent) {
    while (parent.hasChildNodes()) {
      parent.removeChild(parent.firstChild);
    }
    var selectRgbConversion;

    selectRgbConversion = document.createElement('select');
    selectRgbConversion.setAttribute('name', 'rgb_conversion');
    selectRgbConversion.onchange = function() {
      thisClass.rgbConversionChanged(this.value, aData);
    };
    selectRgbConversion.onkeyup = thisClass.enableSaveButton;
    var optionRgbConversion = {};
    optionRgbConversion['hsb'] = document.createElement('option');
    optionRgbConversion.hsb.value = 'hsb';
    optionRgbConversion.hsb.appendChild(document.createTextNode(i18n.translate('rgb_conversion_hsb')));
    optionRgbConversion['xy'] = document.createElement('option');
    optionRgbConversion.xy.value = 'xy';
    optionRgbConversion.xy.appendChild(document.createTextNode(i18n.translate('rgb_conversion_xy')));
    optionRgbConversion['xy_b'] = document.createElement('option');
    optionRgbConversion.xy_b.value = 'xy_b';
    optionRgbConversion.xy_b.appendChild(document.createTextNode(i18n.translate('rgb_conversion_xy_b')));
    if (aData['rgb_conversion'] && optionRgbConversion[aData['rgb_conversion']]) {
      optionRgbConversion[aData['rgb_conversion']].setAttribute('selected', 'selected');
    }
    selectRgbConversion.appendChild(optionRgbConversion.hsb);
    selectRgbConversion.appendChild(optionRgbConversion.xy);
    selectRgbConversion.appendChild(optionRgbConversion.xy_b);
    parent.appendChild(selectRgbConversion);
  }

  // Init function for Datatables, called to create a switch-on brightness selector in the cell described by aData.
  this.createLightSwitchOnBrightness = function(aData, parent) {
    while (parent.hasChildNodes()) {
      parent.removeChild(parent.firstChild);
    }
    var selectSwitchOnBrightness;

    selectSwitchOnBrightness = document.createElement('select');
    selectSwitchOnBrightness.setAttribute('name', 'switch_on_brightness');
    selectSwitchOnBrightness.onchange = function() {
      thisClass.SwitchOnBrightnessChanged(this.value, aData);
    };
    selectSwitchOnBrightness.onkeyup = thisClass.enableSaveButton;

    var optionETSSwitchOnBrightness = document.createElement('option');
    optionETSSwitchOnBrightness.value = -1;
    optionETSSwitchOnBrightness.appendChild(document.createTextNode(i18n.translate('ets_setting') + ' (' + (aData['ets_switch_on_brightness'] == 0 ? i18n.translate('memory_value') : aData['ets_switch_on_brightness'] + '%') + ')'));
    if (aData.switch_on_brightness == -1) {
      optionETSSwitchOnBrightness.setAttribute('selected', 'selected');
    }
    selectSwitchOnBrightness.appendChild(optionETSSwitchOnBrightness);
    var optionSwitchOnlastBrightness = document.createElement('option');
    optionSwitchOnlastBrightness.value = '0';
    optionSwitchOnlastBrightness.appendChild(document.createTextNode(i18n.translate('memory_value')));
    if (aData['switch_on_brightness'] == 0) {
      optionSwitchOnlastBrightness.setAttribute('selected', 'selected');
    }
    selectSwitchOnBrightness.appendChild(optionSwitchOnlastBrightness);

    for (var i = thisClass.switchOnBrightnessIncrement; i <= 100; i += thisClass.switchOnBrightnessIncrement) {
      var optionSwitchOnBrightness = document.createElement('option');
      if (aData['switch_on_brightness'] == i) {
        optionSwitchOnBrightness.setAttribute('selected', 'selected');
      } else if (aData['switch_on_brightness'] > i - thisClass.switchOnBrightnessIncrement && aData['switch_on_brightness'] < i) {
        var optionSwitchOnBrightnessExact = document.createElement('option');
        optionSwitchOnBrightnessExact.value = i;
        optionSwitchOnBrightnessExact.appendChild(document.createTextNode(aData['switch_on_brightness'] + '%'));
        selectSwitchOnBrightness.appendChild(optionSwitchOnBrightnessExact);
        optionSwitchOnBrightnessExact.setAttribute('selected', 'selected');
      }
      optionSwitchOnBrightness.value = i;
      optionSwitchOnBrightness.appendChild(document.createTextNode(i + '%'));
      selectSwitchOnBrightness.appendChild(optionSwitchOnBrightness);
    }
    parent.appendChild(selectSwitchOnBrightness);
  }

  // Init function for Datatables, called to create a dimming mode selector in the cell described by aData.
  this.createDimmingModeSelection = function(aData, parent) {
    while (parent.hasChildNodes()) {
      parent.removeChild(parent.firstChild);
    }
    var selectDimmingModeSelection;

    selectDimmingModeSelection = document.createElement('select');
    selectDimmingModeSelection.setAttribute('name', 'dimming_mode_selection');
    selectDimmingModeSelection.onchange = function() {
      thisClass.DimmingModeSelectionChanged(this.value, aData);
    };
    selectDimmingModeSelection.onkeyup = thisClass.enableSaveButton;

    var optionETSDimmingModeSelection = document.createElement('option');
    optionETSDimmingModeSelection.value = -1;
    optionETSDimmingModeSelection.appendChild(document.createTextNode(i18n.translate('ets_setting') + ' (' + (aData['ets_dimming_mode_selection'] != '-' ? i18n.translate('dimming_mode_selection_' + aData['ets_dimming_mode_selection']) : '-') + ')'));
    if (aData.dimming_mode_selection == -1) {
      optionETSDimmingModeSelection.setAttribute('selected', 'selected');
    }
    selectDimmingModeSelection.appendChild(optionETSDimmingModeSelection);

    for (var i = 0; i <= 2; i++) {
      var optionDimmingModeSelection = document.createElement('option');
      if (aData['dimming_mode_selection'] == i) {
        optionDimmingModeSelection.setAttribute('selected', 'selected');
      }
      optionDimmingModeSelection.value = i;
      optionDimmingModeSelection.appendChild(document.createTextNode(i18n.translate('dimming_mode_selection_' + i)));
      selectDimmingModeSelection.appendChild(optionDimmingModeSelection);
    }
    parent.appendChild(selectDimmingModeSelection);
  }


  // Callback function if the name is changed
  this.lightChanged = function(value, aData) {
    //    console.log("New light name is '" + value + "'");
    // convert incoming possible html text to normal text
    aData['light'] = (value ? value.light : '');
    aData['bridge'] = (value ? value.bridge : '');
    aData['changed'] = true;
    thisClass.enableSaveButton();
    var configurationTable = $(thisClass.configTable).dataTable();
    var currentPagination = configurationTable.api().page();
    configurationTable.fnUpdate(aData['light'], parseInt(aData['number'] - 1), 1);
    // go back to last page after table redraw:
    configurationTable.api().page(currentPagination).draw(false);
  }

  // Callback function if the rgb_conversion is changed
  this.rgbConversionChanged = function(selected, aData) {
    aData['rgb_conversion'] = selected;
    aData['changed'] = true;
    thisClass.enableSaveButton();
    var configurationTable = $(thisClass.configTable).dataTable();
    var currentPagination = configurationTable.api().page();
    configurationTable.fnUpdate(aData['rgb_conversion'], parseInt(aData['number'] - 1), 2);
    // go back to last page after table redraw:
    configurationTable.api().page(currentPagination).draw(false);
  }

  // Callback function if the switch-on brightness is changed
  this.SwitchOnBrightnessChanged = function(selected, aData) {
    aData['switch_on_brightness'] = parseInt(selected);
    aData['changed'] = true;
    thisClass.enableSaveButton();
    var configurationTable = $(thisClass.configTable).dataTable();
    var currentPagination = configurationTable.api().page();
    configurationTable.fnUpdate(aData['switch_on_brightness'], parseInt(aData['number'] - 1), 3);
    // go back to last page after table redraw:
    configurationTable.api().page(currentPagination).draw(false);
  }


  // Callback function if the dimming mode selection is changed
  this.DimmingModeSelectionChanged = function(selected, aData) {
    aData['dimming_mode_selection'] = parseInt(selected);
    aData['changed'] = true;
    thisClass.enableSaveButton();
    var configurationTable = $(thisClass.configTable).dataTable();
    var currentPagination = configurationTable.api().page();
    configurationTable.fnUpdate(aData['dimming_mode_selection'], parseInt(aData['number'] - 1), 4);
    // go back to last page after table redraw:
    configurationTable.api().page(currentPagination).draw(false);
  }

  // Delete mappings table and set internal changed to true, so a save will clear the HueApp list
  this.clearConfiguration = function() {};

  // Save all changed entries to the HueApp
  this.saveMapping = function() {
    var saveRequestMapping = thisClass.createResultingMapping();
    websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.saveMapping(saveRequestMapping, function(response) {
        if (response.response === 'saved') {
          // perhaps it makes sense to reset changed only here, so in case of an error, the user still sees his changes (if we mark them)
          thisClass.setChanged(false);
          mainSite.timer.getBridgeInfo.oneShot();
        } else {
          CreateErrorDialog(i18n.translateAlert('alert_save_mapping') + '\n' + response.response + '!');
        }
      });
    };
    websocket.onerror = function(evt) {
      CreateErrorDialog(i18n.translateAlert('alert_wss_connection'));
    };
  }

  // Create a changed light configuration for the save command and reset the internal changed flag.
  this.createResultingMapping = function() {
    var tabledata = $(thisClass.configTable).DataTable();
    var result = [];
    for (var i = 0; i < tabledata.data().length; i++) {
      var data = tabledata.row(i).data();
      //always send all rows because data.changed is flaky
      {
        // We could add or change an entry (valid light) or delete an entry (light 'none' or light is an empty string).
        if (data.light == '' && data.bridge == '') {
          result.push({
            'number': data.number - 1,
          });
        } else {
          // Ok, light is not empty
          var lightmapping = {
            'number': data.number - 1,
            'bridge_ident': data.bridge,
            'name': data.light,
            'rgb_conversion': data.rgb_conversion
          };
          if (data.switch_on_brightness >= 0) {
            lightmapping['switch_on_brightness'] = data.switch_on_brightness;
          }
          if (data.dimming_mode_selection >= 0) {
            lightmapping['dimming_mode_selection'] = data.dimming_mode_selection;
          }
          result.push(lightmapping);
        }
        // We reset the changed flag here.
        data.changed = false;
      }
    }
    // redraw table
    tabledata.draw(true);
    return result;
  }

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.addCallbackFunction(thisClass.update);
    mainSite.timer.getDeviceInfo.oneShot();

    if (!mainSite.timer.getAppState) {
      mainSite.timer.getAppState = new TimedRequest(INTERVAL.HALFMINUTE, 'getAppState', '', mainSite.setAppState);
      mainSite.timer.getAppState.addCallbackFunction(thisClass.update);
      mainSite.timer.getAppState.oneShot();
    } else {
      mainSite.timer.getAppState.timeout = INTERVAL.HALFMINUTE;
      mainSite.timer.getAppState.addCallbackFunction(thisClass.update);
    }
    mainSite.timer.getAppState.resetTimeout();
    mainSite.timer.getAppState.oneShot();

    if (!mainSite.timer.getBridgeInfo) {
      mainSite.timer.getBridgeInfo = new TimedRequest(INTERVAL.HALFMINUTE, function(value, callback) {
        thisClass.requestBridgesWithLights(callback);
      }, '', function() {});
      mainSite.timer.getBridgeInfo.addCallbackFunction(thisClass.update);
      mainSite.timer.getBridgeInfo.oneShot();
    } else {
      mainSite.timer.getBridgeInfo.timeout = INTERVAL.HALFMINUTE;
      mainSite.timer.getBridgeInfo.addCallbackFunction(thisClass.update);
      mainSite.timer.getBridgeInfo.resetTimeout();
      mainSite.timer.getBridgeInfo.oneShot();
    }
  };
  this.update = function() {
    //update data in site
    for (var i = 0; i < thisClass.dataBindings.length; i++) {
      thisClass.dataBindings[i]();
    }
  };
}

LightConfigurationPage.prototype = new LightConfigurationPage();
LightConfigurationPage.prototype.constructor = LightConfigurationPage;

// Helper to translate between JSON and Datatable fields
function LightMapping(entry) {
  this.number = (entry.number == undefined ? 0 : entry.number) + 1;
  this.bridge = (entry.bridge_ident == undefined ? '' : entry.bridge_ident);
  this.light = (entry.name == undefined ? '' : entry.name);
  this.rgb_conversion = (entry.rgb_conversion == undefined ? 'xy_b' : entry.rgb_conversion);
  this.ets_switch_on_brightness = (entry.ets_switch_on_brightness == undefined ? '-' : entry.ets_switch_on_brightness);
  this.switch_on_brightness = (entry.switch_on_brightness == undefined ? -1 : entry.switch_on_brightness);
  this.ets_dimming_mode_selection = (entry.ets_dimming_mode_selection == undefined ? '-' : entry.ets_dimming_mode_selection);
  this.dimming_mode_selection = (entry.dimming_mode_selection == undefined ? -1 : entry.dimming_mode_selection);
  this.changed = (entry.changed == undefined ? false : entry.changed);
}

function Bridge(name, serial, ip, registered, ident, error_code) {
  this.name = name;
  this.serial = serial;
  this.ip = ip;
  this.registered = registered;
  this.ident = ident;
  this.error_code = error_code;
}

function ModalAddBridgeDialog(thisParent) {
  ModalDialog.call(this, i18n.translate('add_hue_bridge'), i18n.translate('add_bridge_info'));
  var thisClass = this;
  var thisParent = thisParent;
  var thisInfoArea = document.createElement('section');
  var registerButton = undefined;
  var registerBridge = new Bridge();

  this.callbackFunction = function() {};
  this.setCallbackFunction = function(newCallbackFunction) {
    thisClass.callbackFunction = newCallbackFunction;
  };

  this.onRegister = function() {
    websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.invoke_bridge_registration(thisClass.registerBridge, function(response) {
        if (response.response === 'registered') {
          thisClass.callbackFunction(thisClass.registerBridge.ident);
          thisClass.close();
        } else {
          var errorP = document.createElement('p');
          errorP.appendChild(document.createTextNode(i18n.translateAlert('alert_register_app')));
          errorP.appendChild(document.createElement('br'));
          errorP.appendChild(document.createTextNode(i18n.translateAlert(response.response)));
          thisClass.setInfoAreaError(errorP);
          thisClass.inputBox.focus();
        }
      });
    };
  };

  this.onCancel = function() {
    thisClass.callbackFunction('');
    thisClass.close();
  };

  this.addChildElement = function(element) {
    if (element !== undefined) {
      thisClass.modalBody.appendChild(element);
    }
  };

  this.setInfoArea = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert');
    }
  };

  this.resetInfoArea = function() {
    if (thisInfoArea.firstChild !== null) {
      thisInfoArea.removeChild(thisInfoArea.firstChild);
    }
    thisInfoArea.style.visibility = 'hidden';
  };

  this.setInfoAreaWarning = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert alert--warning');
    }
  };

  this.setInfoAreaError = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert alert--error');
    }
  };

  this.prepareDialogText = function() {
    thisClass.addChildElement(document.createElement('br'));
    thisClass.addChildElement(document.createElement('br'));
    thisClass.inputBox = document.createElement('input');
    thisClass.inputBox.setAttribute('type', 'text');
    thisClass.inputBox.setAttribute('list', 'Hue_Bridges');
    thisClass.inputBox.setAttribute('name', 'bridge');
    thisClass.inputBox.setAttribute('autofocus', '');
    thisClass.inputBox.oninput = function() {
      var arrayInputString = this.value.trim().split('- ');
      var ident = arrayInputString[arrayInputString.length - 1];
      if (!ident) {
        ident = this.value;
      }
      if (ident !== '') {
        thisClass.registerBridge = thisParent.getBridgeInfo(ident);
        thisClass.setInfoArea(document.createTextNode(i18n.translate('status_need_registration')));
        thisClass.registerButton.removeAttribute('disabled');
      } else {
        thisClass.registerBridge = new Bridge();
        thisClass.resetInfoArea();
        thisClass.registerButton.setAttribute('disabled', true);
      }
    };
    thisClass.addChildElement(thisClass.inputBox);
    // workaround for buggy apple products:
    if (navigator.userAgent.match(/Macintosh|iPad|Phone|Pod/i) != null) {
      datalist = document.createElement('select');
      dummyOption = document.createElement('option');
      dummyOption.appendChild(document.createTextNode(i18n.translate('please_select_a_value')));
      datalist.appendChild(dummyOption);
      datalist.onchange = function() {
        thisClass.inputBox.value = this.value;
        thisClass.inputBox.oninput();
      }
    } else {
      datalist = document.createElement('datalist');
    }
    // add all available bridges names (sources) to the datalist:
    datalist.setAttribute('id', 'Hue_Bridges');
    datalist.setAttribute('name', 'bridges');
    // datalist events did not work, so react only for inpuBox events: onchange => user leaves the field via enter or clicks another element, so assume input is finished
    // oninput => user enters values or has selected a datalist entry, so enable the register button
    if (thisParent.availableBridges) {
      for (var i = 0; i < thisParent.availableBridges.bridges.length; i++) {
        if (!thisParent.availableBridges.bridges[i].registered) {
          var optionBridges = document.createElement('option');
          if (navigator.userAgent.match(/Macintosh|iPad|Phone|Pod/i) != null) {
            optionBridges.appendChild(document.createTextNode(thisParent.availableBridges.bridges[i].name + ', ID: ' + thisParent.availableBridges.bridges[i].serial.substring(6)));
          }
          optionBridges.value = thisParent.availableBridges.bridges[i].name + ', ID: ' + thisParent.availableBridges.bridges[i].serial.substring(6) + ' - ' + thisParent.availableBridges.bridges[i].serial;
          datalist.appendChild(optionBridges);
        }
      }
    }
    if (navigator.userAgent.match(/Macintosh|iPad|Phone|Pod/i) != null) {
      thisClass.addChildElement(document.createTextNode(i18n.translate('detected_bridges') + ':'));
    }
    thisClass.addChildElement(datalist);

    thisClass.resetInfoArea();
    thisClass.addChildElement(thisInfoArea);
  };

  this.prepare = function() {
    if (!thisClass.modalContainer) {
      thisClass.prepareDialog();
      thisClass.prepareOKCancel();
      thisClass.prepareDialogText();
    }
    thisClass.inputBox.focus();
    return thisClass.modalContainer;
  };

  this.prepareOKCancel = function() {
    var okCancelUl = document.createElement('ul');
    var okLi = document.createElement('li');
    thisClass.registerButton = document.createElement('button');
    thisClass.registerButton.setAttribute('class', 'button--xsm');
    thisClass.registerButton.setAttribute('style', 'width: 100%');
    thisClass.registerButton.setAttribute('disabled', 'true');
    thisClass.registerButton.onclick = thisClass.onRegister;
    thisClass.registerButton.appendChild(document.createTextNode(i18n.translate('register')));
    okLi.appendChild(thisClass.registerButton);
    okCancelUl.appendChild(okLi);
    var cancelLi = document.createElement('li');
    var cancelButton = document.createElement('button');
    cancelButton.setAttribute('class', 'button--xsm');
    cancelButton.setAttribute('style', 'width: 100%');
    cancelButton.onclick = thisClass.onCancel;
    cancelButton.appendChild(document.createTextNode(i18n.translate('btn_cancel')));
    cancelLi.appendChild(cancelButton);
    okCancelUl.appendChild(cancelLi);
    thisClass.modalFooter.appendChild(okCancelUl);
  }
}

ModalAddBridgeDialog.prottype = new ModalDialog();
ModalAddBridgeDialog.prototype.constructor = ModalAddBridgeDialog;

/*
 * ##################################################### End LightConfigurationPage #####################################################
*//*
 * ##################################################### Start SceneConfigurationPage #####################################################
 */

function SceneConfigurationPage() {
  if (!(this instanceof SceneConfigurationPage)) {
    return new SceneConfigurationPage();
  }
  PageTemplate.call(this);
  var thisClass = this;
  this.availableHueScenes = undefined;
  this.maxScenes = 64;
  this.sceneMapping = [];
  this.currentRegisteredBridges = undefined;

  this.divHueDeviceStatus = undefined;
  this.divHueAppStatus = undefined;
  this.divHueSceneMapping = undefined;

  this.prepare = function() {
    if (!thisClass.contentSection) {
      thisClass.contentSection = document.createElement('div');
      thisClass.hueSceneMapping();
      thisClass.noEtsProjectPage();
      thisClass.wrongAppStatePage();
      thisClass.showPageContent(thisClass.divHueSceneMapping);
    }
    mainSite.main.appendChild(thisClass.contentSection);
    thisClass.requestData();
    thisClass.update();
  };

  this.showPageContent = function(pageContent) {
    if (pageContent != thisClass.divHueSceneMapping) {
      if (thisClass.contentSection.contains(thisClass.divHueSceneMapping)) {
        thisClass.contentSection.removeChild(thisClass.divHueSceneMapping);
      }
      if (pageContent == thisClass.divHueDeviceStatus) {
        if (!thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
          if (thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
            thisClass.contentSection.removeChild(thisClass.divHueAppStatus);
          }
          thisClass.contentSection.appendChild(thisClass.divHueDeviceStatus);
        }
      } else {
        if (!thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
          if (thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
            thisClass.contentSection.removeChild(thisClass.divHueDeviceStatus);
          }
          thisClass.contentSection.appendChild(thisClass.divHueAppStatus);
        }
      }
    } else {
      if (!thisClass.contentSection.contains(thisClass.divHueSceneMapping)) {
        if (thisClass.contentSection.contains(thisClass.divHueAppStatus)) {
          thisClass.contentSection.removeChild(thisClass.divHueAppStatus);
        }
        if (thisClass.contentSection.contains(thisClass.divHueDeviceStatus)) {
          thisClass.contentSection.removeChild(thisClass.divHueDeviceStatus);
        }
        thisClass.contentSection.appendChild(thisClass.divHueSceneMapping);
      }
    }
  }

  this.hueSceneMapping = function() {
    if (!thisClass.divHueSceneMapping) {
      thisClass.divHueSceneMapping = document.createElement('div');

      var headerHueScenesConfig = document.createElement('h3');
      headerHueScenesConfig.setAttribute('class', 'h3');
      headerHueScenesConfig.appendChild(document.createTextNode(i18n.translate('scene_title')));
      thisClass.divHueSceneMapping.appendChild(headerHueScenesConfig);

      var spanHueSceneConfigHint = document.createElement('div');
      spanHueSceneConfigHint.setAttribute('class', 'text_hint');
      spanHueSceneConfigHint.appendChild(document.createTextNode(i18n.translate('hue_scene_config_hint')));
      thisClass.divHueSceneMapping.appendChild(spanHueSceneConfigHint);
      thisClass.divHueSceneMapping.appendChild(document.createElement('br'));

      var scenes = document.createElement('div');
      scenes.setAttribute('class', 'iseGrid');
      scenes.setAttribute('id', 'sceneMapping');
      thisClass.divHueSceneMapping.appendChild(scenes);

      var addButton = createGlyphIconButton('plus', 'white');
      addButton.onclick = thisClass.addScene;
      addButton.appendChild(document.createTextNode(i18n.translate('add_scene_button')));
      addButton.setAttribute('id', 'addScene');
      thisClass.divHueSceneMapping.appendChild(addButton);

      thisClass.divHueSceneMapping.appendChild(document.createElement('br'));
      thisClass.divHueSceneMapping.appendChild(document.createElement('br'));

      thisClass.RefreshSceneColumns = function() {
        while (scenes.hasChildNodes()) {
          scenes.removeChild(scenes.childNodes[0]);
        }
        for (var i = 0; i < thisClass.sceneMapping.length; i++) {
          if (i > thisClass.maxScenes) break;
          thisClass.addSceneColumn(thisClass.sceneMapping[i], scenes);
        }
        if (thisClass.sceneMapping.length >= thisClass.maxScenes) {
          addButton.setAttribute('disabled', true);
        } else {
          addButton.removeAttribute('disabled');
        }
      }

      thisClass.dataBindings.push(function() {
        if (thisClass.sceneMapping && thisClass.availableHueScenes) {
          thisClass.RefreshSceneColumns();
        }
      });

      thisClass.dataBindings.push(function() {
        if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload == true && mainSite.appState && mainSite.appState.state == 'Running') {
          thisClass.showPageContent(thisClass.divHueSceneMapping);
        }
      });
    }
  }

  this.RefreshSceneColumns = function() {}

  this.noEtsProjectPage = function() {
    if (!thisClass.divHueDeviceStatus) {
      thisClass.divHueDeviceStatus = document.createElement('div');
      var headerHueDeviceStatus = document.createElement('h3');
      headerHueDeviceStatus.setAttribute('class', 'h3');
      headerHueDeviceStatus.appendChild(document.createTextNode(i18n.translate('error_title_NoEtsProject')));
      var pHueDeviceStatus = document.createElement('p');
      var device_status = document.createTextNode(i18n.translate('error_text_NoEtsProject'));
      pHueDeviceStatus.appendChild(device_status);
      thisClass.divHueDeviceStatus.appendChild(headerHueDeviceStatus);
      thisClass.divHueDeviceStatus.appendChild(pHueDeviceStatus);
      thisClass.divHueDeviceStatus.appendChild(document.createElement('br'));
      thisClass.dataBindings.push(function() {
        if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload == false) {
          thisClass.showPageContent(thisClass.divHueDeviceStatus);
        }
      });
    }
  }

  this.addScene = function() {
    var dialog = new ModalAddSceneDialog(thisClass);
    dialog.prepare();
    dialog.setCallbackFunction(function(number) {
      if (number) {
        setTimeout(mainSite.timer.getSceneMapping.oneShot, INTERVAL.FIVEHUNDREDMILLIS);
      }
    });
    dialog.show();
  }

  this.addSceneColumn = function(scene, parent) {
    if (scene.type == 'cancel_scene') {
      return;
    }
    var sceneColumn = document.createElement('div');
    sceneColumn.setAttribute('id', scene.number);
    var content = document.createElement('p');
    content.setAttribute('class', 'label');
    content.setAttribute('style', 'position: relative;');

    var title = document.createElement('span');
    var sceneNameLabel = document.createElement('b');
    sceneNameLabel.appendChild(document.createTextNode(i18n.translate('scene_name') + ': '));
    var sceneName = document.createTextNode(scene.name);
    title.appendChild(sceneNameLabel);
    title.appendChild(sceneName);

    var statusRow1 = document.createElement('span');
    var sceneNumberLabel = document.createElement('b');
    sceneNumberLabel.appendChild(document.createTextNode(i18n.translate('scene') + ': '));
    var sceneNumber = document.createTextNode(Number(scene.number) + 1);
    statusRow1.appendChild(sceneNumberLabel);
    statusRow1.appendChild(sceneNumber);
    if (scene.cancel_scene !== undefined) {
      var sceneCancelSceneLabel = document.createElement('b');
      sceneCancelSceneLabel.appendChild(document.createTextNode(i18n.translate('scene_cancel_text') + ': '));
      sceneCancelSceneLabel.setAttribute('style', 'margin-left: 1em;');
      var sceneCancelSceneNumber = document.createTextNode(Number(scene.cancel_scene) + 1);
      statusRow1.appendChild(sceneCancelSceneLabel);
      statusRow1.appendChild(sceneCancelSceneNumber);
    }

    var statusRow2 = document.createElement('span');
    var sceneTypeLabel = document.createElement('b');
    sceneTypeLabel.appendChild(document.createTextNode(i18n.translate('scene_type') + ': '));
    var sceneType = document.createTextNode(i18n.translate(scene.type));
    statusRow2.appendChild(sceneTypeLabel);
    statusRow2.appendChild(sceneType);
    statusRow2.appendChild(document.createTextNode(','));
    var sceneAvailabilityLabel = document.createElement('b');
    sceneAvailabilityLabel.setAttribute('style', 'margin-left: 1em;');
    sceneAvailabilityLabel.appendChild(document.createTextNode(i18n.translate('scene_availability') + ': '));
    var sceneAvailability = document.createElement('span');
    var sceneAvailabilityText = document.createTextNode("");
    sceneAvailability.appendChild(sceneAvailabilityText)
    statusRow2.appendChild(sceneAvailabilityLabel);
    statusRow2.appendChild(sceneAvailability);

    var bridgeNames = thisClass.getHueSceneBridges(scene.name);
    if (bridgeNames.length < 1) {
      sceneAvailability.setAttribute('style', 'color:red; font-weight: bold;');
      sceneAvailabilityText.nodeValue = i18n.translate('no_bridge_for_hue_scenes_available');
    } else {
      var duplicateScenes = false;
      var sceneCount = 0;
      for (var i = 0; i < bridgeNames.length; i++) {
        if (i > 0) {
          if (bridgeNames[i] === bridgeNames[i - 1]) {
            duplicateScenes = true;
            sceneCount++;
            if (i == bridgeNames.length - 1) {
              sceneCount++;
              sceneAvailabilityText.nodeValue += ' (' + sceneCount + 'x)';
            }
            continue;
          }
          if (sceneCount > 0) {
            sceneCount++;
            sceneAvailabilityText.nodeValue += ' (' + sceneCount + 'x)';
            sceneCount = 0;
          }
          sceneAvailabilityText.nodeValue += ', ';
        }
        sceneAvailabilityText.nodeValue += bridgeNames[i];
      }
      if (duplicateScenes == true) {
        sceneAvailability.setAttribute('style', 'color:darkorange; font-weight: bold;');
        sceneAvailabilityText.nodeValue += ' - ' + i18n.translate('scene_ambiguous_warning');
      }
    }

    var controls = document.createElement('span');
    controls.setAttribute('style', 'position: absolute; right: 1em; top: 1.5em;');
    var settingsButton = document.createElement('button');
    settingsButton.appendChild(document.createTextNode(decodeURI('\uE137')));
    settingsButton.onclick = function() {
      var dialog = new ModalAddSceneDialog(thisClass, scene.number);
      dialog.prepare();
      dialog.setCallbackFunction(function(number) {
        if (number === '') {
          console.log('Edit scene: canceled!');
        } else {
          console.log('Edit scene: ' + number);
          setTimeout(mainSite.timer.getSceneMapping.oneShot, INTERVAL.FIVEHUNDREDMILLIS);
        }
      });
      dialog.show();
    };

    var buttonRemove = document.createElement('button');
    buttonRemove.appendChild(document.createTextNode(decodeURI('\uE208')));
    buttonRemove.onclick = function() {
      var dialog = new ModalConfirmDialogOkCancel(i18n.translate('remove_scene') + ' - ' + scene.name, i18n.translate('remove_scene_info'));
      dialog.prepare();
      dialog.setCallbackFunction(function(result) {
        if (result) {
          var websocket = CreateWebSocket();
          websocket.onopen = function(evt) {
            var lightMappingSocket = new LightMappingSocket(websocket);
            lightMappingSocket.deleteScenemapping(scene.number, function(response) {
              thisClass.requestHueScenes();
              setTimeout(mainSite.timer.getSceneMapping.oneShot, INTERVAL.FIVEHUNDREDMILLIS);
            });
          };
        }
      });
      dialog.show();
    }

    controls.appendChild(settingsButton);
    controls.appendChild(document.createElement('br'));
    controls.appendChild(buttonRemove);
    // build column
    content.appendChild(controls);
    content.appendChild(title);
    content.appendChild(document.createElement('br'));
    content.appendChild(statusRow1);
    content.appendChild(document.createElement('br'));
    content.appendChild(statusRow2);
    sceneColumn.appendChild(content);
    parent.appendChild(sceneColumn);
  }

  this.getHueSceneBridges = function(name) {
    for (var i = 0; i < thisClass.availableHueScenes.length; i++) {
      if (name == thisClass.availableHueScenes[i].name) {
        return thisClass.availableHueScenes[i].bridge_names;
      }
    }
    // return empty array
    return [];
  }

  this.getScene = function(number) {
    if (number != undefined) {
      for (var i = 0; i < thisClass.sceneMapping.length; i++) {
        if (thisClass.sceneMapping[i].number == number) {
          var scene = thisClass.sceneMapping[i];
          return new Scene(scene.number, scene.type, scene.name, scene.blink_time, scene.restore_time, scene.cancel_scene, scene.signal_scene);
        }
      }
    }
    return new Scene();
  }

  thisClass.updateSceneMappings = function(mappings) {
    mappings.sort(function(a, b) {
      return Number(a.number) - Number(b.number);
    });
    thisClass.sceneMapping = mappings;
  }

  this.requestSceneMappings = function(callback) {
    var websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.getSceneMappings(function(response) {
        if (response.response == 'scenemappings') {
          thisClass.updateSceneMappings(response.mappings);
          if (callback) {
            callback();
          }
          websocket.close();
        }
      });
    };
    websocket.onerror = function(evt) {
      thisClass.currentLightMapping = undefined;
    };
  }

  this.requestHueScenes = function(callback) {
    var websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.getHueScenes(function(response) {
        if (response.response == 'hue_scenes') {
          thisClass.availableHueScenes = response.scenes.sort(function(a, b) {
            return (a.name.toUpperCase() > b.name.toUpperCase()) - (a.name.toUpperCase() < b.name.toUpperCase());
          });
          thisClass.requestLightsAndMappings();
          thisClass.requestSceneMappings(callback);
          websocket.close();
        }
      });
    };
    websocket.onerror = function(evt) {
      thisClass.availableHueScenes = undefined;
    };
  }


  this.requestLightsAndMappings = function() {
    var websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      lightMappingSocket.getBridgeAndLightMapping(function(response) {
        if (response.response == 'bridge_and_light_mappings') {
          thisClass.currentRegisteredBridges = response.registered_bridges;
          websocket.close();
        }
      });
    };
    websocket.onerror = function(evt) {
      thisClass.currentRegisteredBridges = undefined;
    };
  }

  this.wrongAppStatePage = function() {
    if (!thisClass.divHueAppStatus) {
      thisClass.divHueAppStatus = document.createElement('div');
      var headerHueAppStatus = document.createElement('h3');
      headerHueAppStatus.setAttribute('class', 'h3');
      headerHueAppStatus.appendChild(document.createTextNode(i18n.translate('error_title_WrongAppState')));
      var pHueAppStatus = document.createElement('p');
      var hue_status = document.createTextNode(i18n.translate('error_text_WrongAppState_na'));
      pHueAppStatus.appendChild(hue_status);
      thisClass.divHueAppStatus.appendChild(headerHueAppStatus);
      thisClass.divHueAppStatus.appendChild(pHueAppStatus);
      thisClass.divHueAppStatus.appendChild(document.createElement('br'));

      thisClass.dataBindings.push(function() {
        if (mainSite.appState && mainSite.appState.state != 'Running' && mainSite.deviceInfo.EtsDownload == true) {
          switch (mainSite.appState.state) {
            case 'Stopped':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_0');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            case 'Starting':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_1');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            case 'Stopping':
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_3');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
            default:
              hue_status.nodeValue = i18n.translate('error_text_WrongAppState_na');
              thisClass.showPageContent(thisClass.divHueAppStatus);
              break;
          }
        } else if (!mainSite.appState && mainSite.deviceInfo.EtsDownload == true) {
          hue_status.nodeValue = i18n.translate('error_text_WrongAppState_na');
          thisClass.showPageContent(thisClass.divHueAppStatus);
        }
      });

    }
  }

  this.requestData = function() {
    mainSite.timer.getDeviceInfo.addCallbackFunction(thisClass.update);
    mainSite.timer.getDeviceInfo.oneShot();

    if (!mainSite.timer.getAppState) {
      mainSite.timer.getAppState = new TimedRequest(INTERVAL.HALFMINUTE, 'getAppState', '', mainSite.setAppState);
      mainSite.timer.getAppState.addCallbackFunction(thisClass.update);
      mainSite.timer.getAppState.oneShot();
    } else {
      mainSite.timer.getAppState.timeout = INTERVAL.HALFMINUTE;
      mainSite.timer.getAppState.addCallbackFunction(thisClass.update);
    }
    mainSite.timer.getAppState.resetTimeout();
    mainSite.timer.getAppState.oneShot();

    if (!mainSite.timer.getSceneMapping) {
      mainSite.timer.getSceneMapping = new TimedRequest(INTERVAL.HALFMINUTE, function(value, callback) {
        thisClass.requestHueScenes(callback);
      }, '', function() {});
      mainSite.timer.getSceneMapping.addCallbackFunction(thisClass.update);
      mainSite.timer.getSceneMapping.oneShot();
    } else {
      mainSite.timer.getSceneMapping.timeout = INTERVAL.HALFMINUTE;
      mainSite.timer.getSceneMapping.addCallbackFunction(thisClass.update);
      mainSite.timer.getSceneMapping.resetTimeout();
      mainSite.timer.getSceneMapping.oneShot();
    }
  };
  this.update = function() {
    //update data in site
    for (var i = 0; i < thisClass.dataBindings.length; i++) {
      thisClass.dataBindings[i]();
    }
  };
}

SceneConfigurationPage.prototype = new SceneConfigurationPage();
SceneConfigurationPage.prototype.constructor = SceneConfigurationPage;


// if not set, it must remain undefined!
function Scene(number, type, name, blink_time, restore_time, cancel_scene, signal_scene) {
  this.number = number;
  this.type = type;
  this.name = name;
  this.blink_time = blink_time;
  this.restore_time = restore_time;
  this.cancel_scene = cancel_scene;
  this.signal_scene = signal_scene;

  this.compare = function(otherScene) {
    var thisSceneStr = JSON.stringify(this);
    var otherSceneStr = JSON.stringify(otherScene);
    return (thisSceneStr == otherSceneStr);
  }
}

function ModalAddSceneDialog(thisParent, sceneNumber) {
  ModalDialog.call(this, i18n.translate('scene_config'), i18n.translate('add_scene_info'));
  this.id = 'SceneDialog';
  var thisClass = this;
  var thisParent = thisParent;
  var thisInfoArea = document.createElement('section');
  var saveSceneButton = undefined;
  var editScene = (sceneNumber == undefined ? new Scene(undefined, 'hue_scene') : thisParent.getScene(sceneNumber));
  var oldSceneNumber = undefined;
  var oldCancelScene = editScene.cancel_scene;

  this.callbackFunction = function() {};
  this.setCallbackFunction = function(newCallbackFunction) {
    thisClass.callbackFunction = newCallbackFunction;
  };

  this.onSaveScene = function() {
    websocket = CreateWebSocket();
    websocket.onopen = function(evt) {
      var lightMappingSocket = new LightMappingSocket(websocket);
      if (oldSceneNumber !== undefined && oldSceneNumber !== editScene.number) {
        lightMappingSocket.deleteScenemapping(oldSceneNumber, function(response) {
          // TODO: hmm delete failed...!?
        });
      }
      oldSceneNumber = undefined;
      lightMappingSocket.saveScenemapping(editScene, function(response) {
        if (response.response === 'success') {
          thisClass.callbackFunction(editScene.name);
          thisClass.close();
        } else {
          var errorP = document.createElement('p');
          errorP.appendChild(document.createTextNode(i18n.translateAlert('alert_save_scene')));
          errorP.appendChild(document.createElement('br'));
          errorP.appendChild(document.createTextNode(i18n.translateAlert(response.response)));
          thisClass.setInfoAreaError(errorP);
          thisClass.sceneNumberSelect.focus();
        }
      });
    };
  };

  this.onCancel = function() {
    thisClass.callbackFunction('');
    thisClass.close();
  };

  this.addChildElement = function(element) {
    if (element !== undefined) {
      thisClass.modalBody.appendChild(element);
    }
  };

  this.setInfoArea = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert');
    }
  };

  this.resetInfoArea = function() {
    if (thisInfoArea.firstChild !== null) {
      thisInfoArea.removeChild(thisInfoArea.firstChild);
    }
    thisInfoArea.style.visibility = 'hidden';
  };

  this.setInfoAreaWarning = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert alert--warning');
    }
  };

  this.setInfoAreaError = function(element) {
    thisClass.resetInfoArea();
    if (element !== undefined) {
      thisInfoArea.appendChild(element);
      thisInfoArea.style.visibility = 'visible';
      thisInfoArea.setAttribute('class', 'alert alert--error');
    }
  };

  this.checkSaveButton = function() {
    // called after an element has been changed, checks if all requirements are fullfilled to enable the save button:
    if (editScene.name != undefined && editScene.number != undefined && !editScene.compare(thisParent.getScene(editScene.number))) {
      if (editScene.blink_time == 'inf' && thisClass.cancelSceneNumberSelect.length == 0 && editScene.cancel_scene == undefined) {
        thisClass.saveSceneButton.setAttribute('disabled', true);
        thisClass.setEndlessWarning();
      } else {
        thisClass.saveSceneButton.removeAttribute('disabled');
      }
    } else {
      thisClass.saveSceneButton.setAttribute('disabled', true);
    }
  }

  this.createDurations = function(customTime) {
    thisClass.durationArray = [];
    var index = 0;
    if (customTime && customTime == 'inf')
      customTime = undefined;
    thisClass.durationArray[index++] = {
      label: i18n.translate('endless'),
      duration: 'inf'
    };
    for (var i = 5; i <= 30; i += 5) {
      var labelL = '00:' + (i < 10 ? '0' : '') + i;
      var durationSeconds = i;
      if (customTime && customTime <= durationSeconds) {
        if (customTime != durationSeconds) {
          thisClass.durationArray[index++] = {
            label: (Math.floor(customTime / 60) < 10 ? '0' : '') + Math.floor(customTime / 60) + ':' + (customTime % 60 < 10 ? '0' : '') + customTime % 60,
            duration: customTime
          };
        }
        customTime = undefined;
      }
      thisClass.durationArray[index++] = {
        label: labelL,
        duration: durationSeconds
      };
    }
    for (var i = 1; i <= 60; i++) {
      var labelL = (i < 10 ? '0' : '') + i + ':00';
      var durationSeconds = i * 60;
      if (customTime && customTime <= durationSeconds) {
        if (customTime != durationSeconds) {
          thisClass.durationArray[index++] = {
            label: (Math.floor(customTime / 60) < 10 ? '0' : '') + Math.floor(customTime / 60) + ':' + (customTime % 60 < 10 ? '0' : '') + customTime % 60,
            duration: customTime
          };
        }
        customTime = undefined;
      }
      thisClass.durationArray[index++] = {
        label: labelL,
        duration: durationSeconds
      };
    }
  }

  this.getDurationTimeFromLabel = function(label) {
    for (var i = 0; i < thisClass.durationArray.length; i++) {
      if (thisClass.durationArray[i].label == label) {
        return thisClass.durationArray[i].duration;
      }
    }

    var duration = label.split(':');
    if (duration.length == 2) {
      return Number(duration[0]) * 60 + Number(duration[1]);
    }
    return thisClass.durationArray[0].duration;
  }

  this.createLabel = function(translate_id) {
    var label = document.createElement('label');
    label.appendChild(document.createTextNode(i18n.translate(translate_id)));
    label.setAttribute('for', translate_id);
    return label;
  }

  this.createRow = function(firstColumnObject, secondColumnObject, firstColumnSize) {
    var maxColumns = 12;
    var row = document.createElement('div');
    row.setAttribute('row', '');
    row.setAttribute('style', 'padding-bottom:5px;');
    var column1 = document.createElement('div');
    if (firstColumnSize == undefined) {
      if (secondColumnObject) {
        firstColumnSize = 3;
      } else {
        firstColumnSize = maxColumns;
      }
    }
    column1.setAttribute('column', firstColumnSize);
    column1.setAttribute('style', 'padding:0px;');
    if (firstColumnObject) {
      column1.appendChild(firstColumnObject);
    } else {
      var span = document.createElement('span');
      span.appendChild(document.createTextNode('\u00A0'));
      column1.appendChild(span);
    }
    row.appendChild(column1);
    if (secondColumnObject) {
      var column2 = document.createElement('div');
      column2.setAttribute('column', Number(maxColumns - firstColumnSize));
      column2.setAttribute('style', 'padding:0px;');
      column2.appendChild(secondColumnObject);
      row.appendChild(column2);
    }
    return row;
  }

  this.updateCancelSceneOptions = function() {
    while (thisClass.cancelSceneNumberSelect.hasChildNodes()) {
      thisClass.cancelSceneNumberSelect.removeChild(thisClass.cancelSceneNumberSelect.childNodes[0]);
    }
    // get selected scene number in dialog and add all free numbers expect the selected one
    for (var i = 0; i < thisParent.maxScenes; i++) {
      if (i + 1 == thisClass.sceneNumberSelect.value) {
        // already selected as scene number, so skip
        continue;
      }
      var sceneI = thisParent.getScene(i);
      if (sceneI.number == i && sceneI.type == 'hue_scene') {
        // already stored as scene number, so skip
        continue;
      }
      if (oldCancelScene != sceneI.number) {
        if (editScene.cancel_scene == undefined && sceneI.type == 'cancel_scene' && sceneI.number == i && Number(sceneI.signal_scene) + 1 != thisClass.sceneNumberSelect.value) {
          // we have no selected cancel_scene and this is a cancel scene but fits not to the selected signal_scene, so skip
          continue;
        }
        if (editScene.cancel_scene != sceneI.number && sceneI.type == 'cancel_scene') {
          // we have no selected cancel_scene and this is a cancel scene but fits not to the selected signal_scene, so skip
          continue;
        }
      }
      var optionCancelSceneNumber = document.createElement('option');
      optionCancelSceneNumber.appendChild(document.createTextNode(i + 1));
      optionCancelSceneNumber.value = i + 1;
      thisClass.cancelSceneNumberSelect.appendChild(optionCancelSceneNumber);
      // the first empty number is the new cancel scene number:
      if (editScene.cancel_scene == undefined && thisClass.useCancelScene.checked) {
        editScene.cancel_scene = i;
      }
      if (i == editScene.cancel_scene) {
        optionCancelSceneNumber.setAttribute('selected', '');
      }
    }
  }

  this.updateHueSceneOptions = function() {
    while (thisClass.sceneNameSelect.hasChildNodes()) {
      thisClass.sceneNameSelect.removeChild(thisClass.sceneNameSelect.childNodes[0]);
    }
    if (thisParent.availableHueScenes) {
      for (var i = 0; i < thisParent.availableHueScenes.length; i++) {

        var sceneOptionText = thisParent.availableHueScenes[i].name;
        if (thisParent.currentRegisteredBridges.length > 1) {
          var numAvailableOnRegistredBridges = {};
          for (var j = 0; j < thisParent.availableHueScenes[i].bridge_names.length; j++) {
            for (var k = 0; k < thisParent.currentRegisteredBridges.length; k++) {
              if (thisParent.currentRegisteredBridges[k].name == thisParent.availableHueScenes[i].bridge_names[j]) {
                numAvailableOnRegistredBridges[thisParent.currentRegisteredBridges[k].name] = 1;
              }
            }
          }
          numAvailableOnRegistredBridges.length = Object.keys(numAvailableOnRegistredBridges).length;
          switch (numAvailableOnRegistredBridges.length) {
            case 1:
              break;
            case thisParent.currentRegisteredBridges.length:
              sceneOptionText += ' (' + i18n.translate('all_bridges') + ')';
              break;
            default:
              sceneOptionText += ' (' + numAvailableOnRegistredBridges.length + ' ' + i18n.translate('bridges') + ')';
          }
        }

        var optionHueScenes = document.createElement('option');
        optionHueScenes.appendChild(document.createTextNode(sceneOptionText));
        optionHueScenes.value = thisParent.availableHueScenes[i].name;
        // if undefined, first Hue scene becomes pre-selected
        if (editScene.name === undefined) {
          editScene.name = thisParent.availableHueScenes[i].name;
        }
        if (thisParent.availableHueScenes[i].name == editScene.name) {
          optionHueScenes.setAttribute('selected', '');
        }
        thisClass.sceneNameSelect.appendChild(optionHueScenes);
      }
    }
  }

  this.setEndlessWarning = function() {
    if (!thisClass.endlessWarnP) {
      thisClass.endlessWarnP = document.createElement('p');
      if (thisClass.cancelSceneNumberSelect.length == 0) {
        thisClass.endlessWarnP.appendChild(document.createTextNode(i18n.translateAlert('scene_endless_warn_1')));
      } else {
        thisClass.endlessWarnP.appendChild(document.createTextNode(i18n.translateAlert('scene_endless_warn_0')));
      }
      thisClass.setInfoAreaWarning(thisClass.endlessWarnP);
    }
  }
  this.resetEndlessWarning = function() {
    if (thisClass.endlessWarnP) {
      thisClass.endlessWarnP = undefined;
      thisClass.resetInfoArea();
    }
  }

  this.prepareDialogText = function() {
    var divSceneConfig = document.createElement('div');
    divSceneConfig.setAttribute('class', 'form--inline');
    divSceneConfig.setAttribute('container', '');
    divSceneConfig.setAttribute('style', 'padding:0px;padding-bottom: 2px;');
    var calledToAdd = false;
    if (editScene.number === undefined) {
      calledToAdd = true;
    }

    // scene number select    
    thisClass.sceneNumberSelect = document.createElement('select');
    thisClass.sceneNumberSelect.setAttribute('name', 'scene_number');
    thisClass.sceneNumberSelect.onchange = function() {
      if (!calledToAdd && oldSceneNumber === undefined) {
        oldSceneNumber = editScene.number;
      }
      editScene.number = (this.value != '' ? Number(this.value) - 1 : undefined);
      thisClass.updateCancelSceneOptions();
      thisClass.checkSaveButton();
    }

    for (var i = 0; i < thisParent.maxScenes; i++) {
      if (thisParent.getScene(i).type == undefined || i == editScene.number || i == oldSceneNumber) {
        // the first empty number is the new scene number:
        if (editScene.number == undefined) {
          editScene.number = i;
        }
        var optionSceneNumber = document.createElement('option');
        optionSceneNumber.appendChild(document.createTextNode(i + 1));
        optionSceneNumber.value = i + 1;
        if (editScene.number == i) {
          optionSceneNumber.setAttribute('selected', '');
        }
        thisClass.sceneNumberSelect.appendChild(optionSceneNumber);
      }
    }
    divSceneConfig.appendChild(thisClass.createRow(thisClass.createLabel('scene_number'), thisClass.sceneNumberSelect));

    // Hue scene name select; TODO: expand this if we have more than Hue Scenes
    thisClass.sceneNameSelect = document.createElement('select');
    thisClass.sceneNameSelect.setAttribute('name', 'scene_name');
    thisClass.sceneNameSelect.setAttribute('id', 'scene_name');
    thisClass.sceneNameSelect.setAttribute('style', 'width:80%');
    thisClass.sceneNameSelect.onchange = function() {
      editScene.name = this.value;
      thisClass.checkSaveButton();
    }
    thisClass.updateHueSceneOptions();

    var buttonRefresh = document.createElement('button');
    buttonRefresh.appendChild(document.createTextNode(decodeURI('\uE082')));
    buttonRefresh.onclick = function() {
      thisClass.sceneNameSelect.setAttribute('disabled', true);
      while (thisClass.sceneNameSelect.hasChildNodes()) {
        thisClass.sceneNameSelect.removeChild(thisClass.sceneNameSelect.childNodes[0]);
      }
      var websocket = CreateWebSocket();
      websocket.onopen = function(evt) {
        var lightMappingSocket = new LightMappingSocket(websocket);
        lightMappingSocket.getHueScenes(function(response) {
          if (response.response == 'hue_scenes') {
            thisParent.availableHueScenes = response.scenes.sort(function(a, b) {
              return (a.name.toUpperCase() > b.name.toUpperCase()) - (a.name.toUpperCase() < b.name.toUpperCase());
            });
            websocket.close();
          }
          thisClass.updateHueSceneOptions();
          thisClass.sceneNameSelect.removeAttribute('disabled');
          thisClass.checkSaveButton();
          thisParent.RefreshSceneColumns();
        }, false);
      };
      websocket.onerror = function(evt) {
        thisParent.availableHueScenes = undefined;
        thisClass.updateHueSceneOptions();
        thisClass.sceneNameSelect.removeAttribute('disabled');
        thisClass.checkSaveButton();
      };
    }
    buttonRefresh.setAttribute('style', 'float:inherit;color:black;font:18px/1em "Glyphicons Regular"');
    var spanSceneName = document.createElement('span');
    spanSceneName.setAttribute('class', 'iseGrid');
    spanSceneName.appendChild(thisClass.sceneNameSelect);
    spanSceneName.appendChild(document.createTextNode('\u00A0'));
    spanSceneName.appendChild(document.createTextNode('\u00A0'));
    spanSceneName.appendChild(buttonRefresh);
    divSceneConfig.appendChild(thisClass.createRow(thisClass.createLabel('scene_name'), spanSceneName));
    // add Hue scene info text as row
    var pAddSceneInfo = document.createElement('p');
    pAddSceneInfo.appendChild(document.createTextNode(i18n.translate('scene_name_info')));
    pAddSceneInfo.setAttribute('class', 'input--help');
    divSceneConfig.appendChild(thisClass.createRow(pAddSceneInfo, undefined, 12));

    // signal flashing checkbox with duration select
    var pSignalFlashing = document.createElement('p');

    divSceneConfig.appendChild(thisClass.createRow(thisClass.createLabel('scene_signalflashing'), pSignalFlashing));

    thisClass.flashingCheckbox = document.createElement('input');
    thisClass.flashingCheckbox.setAttribute('type', 'checkbox');
    thisClass.flashingCheckbox.setAttribute('name', 'scene_signalflashing');
    thisClass.flashingCheckbox.onchange = function() {
      if (this.checked) {
        // enable optional flashing elements and set their default values in editScene!
        thisClass.durationSelect.removeAttribute('disabled');
        thisClass.customTimeText.removeAttribute('disabled');
        if (thisClass.cancelSceneNumberSelect.length == 0 && editScene.cancel_scene == undefined) {
          thisClass.durationSelect[0].setAttribute('disabled', true);
          thisClass.durationSelect.selectedIndex = 1;
        } else {
          thisClass.durationSelect[0].removeAttribute('disabled', true);
        }
        thisClass.customTimeText.value = thisClass.durationSelect.value;
        editScene.blink_time = thisClass.getDurationTimeFromLabel(thisClass.customTimeText.value);
        thisClass.restoreOriginalState.removeAttribute('disabled');
        if (thisClass.restoreOriginalState.checked) {
          editScene.restore_time = thisClass.getDurationTimeFromLabel(thisClass.customTimeText.value);
          if (editScene.restore_time == 'inf') {
            editScene.restore_time = 1;
          }
        }
        if (editScene.blink_time != 'inf' && !(thisClass.cancelSceneNumberSelect.length == 0 && editScene.cancel_scene == undefined)) {
          thisClass.useCancelScene.removeAttribute('disabled');
        } else {
          if (oldCancelScene != undefined) {
            editScene.cancel_scene = oldCancelScene;
          } else {
            thisClass.useCancelScene.checked = true;
            thisClass.useCancelScene.onchange();
          }
          thisClass.setEndlessWarning();
        }
        if (thisClass.useCancelScene.checked) {
          thisClass.cancelSceneNumberSelect.removeAttribute('disabled');
        }
      } else {
        thisClass.resetEndlessWarning();
        // if disabled, disable all other optional flashing elements
        thisClass.customTimeText.setAttribute('disabled', true);
        thisClass.durationSelect.setAttribute('disabled', true);
        thisClass.restoreOriginalState.setAttribute('disabled', true);
        thisClass.useCancelScene.setAttribute('disabled', true);
        if (thisClass.useCancelScene.checked) {
          thisClass.cancelSceneNumberSelect.setAttribute('disabled', true);
        }
        // set also all values to undefinded
        editScene.blink_time = undefined;
        editScene.restore_time = undefined;
        editScene.cancel_scene = undefined;
        editScene.signal_scene = undefined;
      }
      thisClass.checkSaveButton();
    }
    if (editScene.blink_time && editScene.blink_time != 0) {
      thisClass.flashingCheckbox.checked = true;
    }
    pSignalFlashing.appendChild(thisClass.flashingCheckbox);


    pSignalFlashing.appendChild(thisClass.createLabel('scene_duration'));
    pSignalFlashing.appendChild(document.createTextNode(' '));

    thisClass.customTimeText = document.createElement('input');
    thisClass.customTimeText.setAttribute('type', 'text');
    thisClass.customTimeText.setAttribute('pattern', '^(' + i18n.translate('endless') + ')|((0[0-9]|[1-9][0-9]+):([0-5][0-9]))$');
    var patternTester = new RegExp(thisClass.customTimeText.getAttribute("pattern"));
    thisClass.customTimeText.onkeyup = function(evt) {
      if (patternTester.test(evt.target.value)) {
        if (evt.target.value == i18n.translate('endless') && thisClass.cancelSceneNumberSelect.length == 0 && editScene.cancel_scene == undefined) {
          thisClass.saveSceneButton.setAttribute('disabled', true);
          thisClass.setEndlessWarning();
          return false;
        }
        editScene.blink_time = thisClass.getDurationTimeFromLabel(evt.target.value);
        if (thisClass.restoreOriginalState.checked) {
          editScene.restore_time = editScene.blink_time;
          if (editScene.restore_time == 'inf') {
            editScene.restore_time = 1;
          }
        }
        if (editScene.blink_time == 'inf') {
          thisClass.useCancelScene.checked = true;
          thisClass.setEndlessWarning();
        } else {
          thisClass.resetEndlessWarning();
        }
        thisClass.checkSaveButton();
      } else {
        thisClass.saveSceneButton.setAttribute('disabled', true);
      }
    };


    thisClass.durationSelect = document.createElement('select');
    thisClass.durationSelect.setAttribute('name', 'scene_duration');

    if (!thisClass.flashingCheckbox.checked) {
      thisClass.customTimeText.setAttribute('disabled', true);
      thisClass.durationSelect.setAttribute('disabled', true);
    }
    thisClass.durationSelect.onchange = function() {
      thisClass.customTimeText.value = this.value;
      editScene.blink_time = thisClass.getDurationTimeFromLabel(this.value);
      if (thisClass.restoreOriginalState.checked) {
        editScene.restore_time = editScene.blink_time;
        if (editScene.restore_time == 'inf') {
          editScene.restore_time = 1;
        }
      }
      if (editScene.blink_time == 'inf') {
        thisClass.useCancelScene.setAttribute('disabled', true);
        if (!thisClass.useCancelScene.checked) {
          thisClass.useCancelScene.checked = true;
          thisClass.useCancelScene.onchange(true);
        }
        thisClass.setEndlessWarning();
      } else {
        thisClass.resetEndlessWarning();
        if (thisClass.cancelSceneNumberSelect.length != 0 && editScene.cancel_scene != undefined) {
          thisClass.useCancelScene.removeAttribute('disabled');
        }
      }
      thisClass.checkSaveButton();
    }
    thisClass.createDurations(editScene.blink_time);
    thisClass.customTimeText.setAttribute('id', 'customTimeText');
    thisClass.durationSelect.setAttribute('id', 'durationSelect');
    thisClass.durationSelect.addEventListener('focus', function() {
      thisClass.customTimeText.setAttribute('class', 'customTimeTextFocus');
    }, true);
    thisClass.durationSelect.addEventListener('blur', function() {
      thisClass.customTimeText.removeAttribute('class')
    }, true);

    for (var i = 0; i < thisClass.durationArray.length; i++) {
      var optionDuration = document.createElement('option');
      optionDuration.appendChild(document.createTextNode(thisClass.durationArray[i].label));
      optionDuration.value = thisClass.durationArray[i].label;
      if (thisClass.durationArray[i].duration == editScene.blink_time) {
        optionDuration.setAttribute('selected', '');
        thisClass.customTimeText.value = thisClass.durationArray[i].label;
      }
      thisClass.durationSelect.appendChild(optionDuration);
    }
    var divDurationSelection = document.createElement('div');
    divDurationSelection.setAttribute('class', 'groupedfocus');
    divDurationSelection.appendChild(thisClass.customTimeText);
    divDurationSelection.appendChild(thisClass.durationSelect);
    pSignalFlashing.appendChild(divDurationSelection);

    var signalDurationUnit = document.createElement('span');
    signalDurationUnit.setAttribute('style', 'font-size:0.875em;vertical-align:middle');
    signalDurationUnit.appendChild(document.createTextNode(' ' + i18n.translate('scene_duration_unit')));
    pSignalFlashing.appendChild(signalDurationUnit);

    // optional flashing restore origin select
    thisClass.restoreOriginalState = document.createElement('input');
    thisClass.restoreOriginalState.setAttribute('type', 'checkbox');
    thisClass.restoreOriginalState.setAttribute('name', 'scene_restore');
    if (!thisClass.flashingCheckbox.checked) {
      thisClass.restoreOriginalState.setAttribute('disabled', true);
    }
    thisClass.restoreOriginalState.onchange = function() {
      if (this.checked) {
        editScene.restore_time = thisClass.getDurationTimeFromLabel(thisClass.durationSelect.value);
        if (editScene.restore_time == 'inf') {
          editScene.restore_time = 1;
        }
      } else {
        editScene.restore_time = undefined;
      }
      thisClass.checkSaveButton();
    }
    if (editScene.restore_time > 0) {
      thisClass.restoreOriginalState.checked = true;
    }
    pSignalFlashing.appendChild(document.createElement('br'));
    pSignalFlashing.appendChild(thisClass.restoreOriginalState);
    var labelSceneRestore = document.createElement('span');
    labelSceneRestore.setAttribute('style', 'font-size:0.875em;vertical-align:middle;margin-left:1em;');
    labelSceneRestore.appendChild(document.createTextNode(i18n.translate('scene_restore')));
    pSignalFlashing.appendChild(labelSceneRestore);

    // optional flashing cancel select
    thisClass.useCancelScene = document.createElement('input');
    thisClass.useCancelScene.setAttribute('type', 'checkbox');
    thisClass.useCancelScene.setAttribute('name', 'scene_cancel_text');
    if (!thisClass.flashingCheckbox.checked) {
      thisClass.useCancelScene.setAttribute('disabled', true);
    }
    if (editScene.blink_time == 'inf') {
      thisClass.useCancelScene.setAttribute('disabled', true);
      if (!thisClass.useCancelScene.checked) {
        thisClass.useCancelScene.checked = true;
      }
    }
    thisClass.useCancelScene.onchange = function() {
      if (this.checked) {
        if (thisClass.cancelSceneNumberSelect.length == 0) {
          this.checked = false;
          return false;
        }
        thisClass.cancelSceneNumberSelect.removeAttribute('disabled');
        thisClass.updateCancelSceneOptions();
        editScene.cancel_scene = Number(thisClass.cancelSceneNumberSelect.value) - 1;
      } else {
        if (editScene.blink_time == 'inf') {
          return false;
        }
        thisClass.cancelSceneNumberSelect.setAttribute('disabled', true);
        editScene.cancel_scene = undefined;
      }
      thisClass.checkSaveButton();
    }
    if (editScene.cancel_scene !== undefined) {
      thisClass.useCancelScene.checked = true;
    }
    pSignalFlashing.appendChild(document.createElement('br'));
    pSignalFlashing.appendChild(thisClass.useCancelScene);

    var labelCancelScene = document.createElement('span');
    labelCancelScene.setAttribute('style', 'font-size:0.875em;vertical-align:middle;margin-left:1em;');
    labelCancelScene.appendChild(document.createTextNode(i18n.translate('scene_cancel_text')));
    pSignalFlashing.appendChild(labelCancelScene);
    pSignalFlashing.appendChild(document.createTextNode(' '));

    thisClass.cancelSceneNumberSelect = document.createElement('select');
    thisClass.cancelSceneNumberSelect.setAttribute('name', 'cancel_scene_number');
    thisClass.cancelSceneNumberSelect.onchange = function() {
      editScene.cancel_scene = (this.value != '' ? Number(this.value) - 1 : undefined);
      thisClass.checkSaveButton();
    }
    thisClass.updateCancelSceneOptions();
    if (!thisClass.useCancelScene.checked || thisClass.cancelSceneNumberSelect.length == 0) {
      thisClass.cancelSceneNumberSelect.setAttribute('disabled', true);
    }
    pSignalFlashing.appendChild(thisClass.cancelSceneNumberSelect);

    // if called as addScene, enable save if possible
    if (calledToAdd) {
      thisClass.checkSaveButton();
    }

    // now add the element
    thisClass.addChildElement(divSceneConfig);

    thisClass.resetInfoArea();
    thisClass.addChildElement(thisInfoArea);
  };

  this.prepare = function() {
    if (!thisClass.modalContainer) {
      thisClass.prepareDialog();
      thisClass.prepareOKCancel();
      thisClass.prepareDialogText();
    }
    // todo call focus() if dialog is visible for the desired input element, e.g. thisClass.sceneNumberSelect.focus();
    thisClass.sceneNumberSelect.focus();
    return thisClass.modalContainer;
  };

  this.prepareOKCancel = function() {
    var okCancelUl = document.createElement('ul');
    var okLi = document.createElement('li');
    thisClass.saveSceneButton = document.createElement('button');
    thisClass.saveSceneButton.setAttribute('class', 'button--xsm');
    thisClass.saveSceneButton.setAttribute('style', 'width: 100%');
    thisClass.saveSceneButton.setAttribute('disabled', 'true');
    thisClass.saveSceneButton.onclick = thisClass.onSaveScene;
    thisClass.saveSceneButton.appendChild(document.createTextNode(i18n.translate('save_scene_config')));
    okLi.appendChild(thisClass.saveSceneButton);
    okCancelUl.appendChild(okLi);
    var cancelLi = document.createElement('li');
    var cancelButton = document.createElement('button');
    cancelButton.setAttribute('class', 'button--xsm');
    cancelButton.setAttribute('style', 'width: 100%');
    cancelButton.onclick = thisClass.onCancel;
    cancelButton.appendChild(document.createTextNode(i18n.translate('btn_cancel')));
    cancelLi.appendChild(cancelButton);
    okCancelUl.appendChild(cancelLi);
    thisClass.modalFooter.appendChild(okCancelUl);
  }
}

ModalAddSceneDialog.prottype = new ModalDialog();
ModalAddSceneDialog.prototype.constructor = ModalAddSceneDialog;

/*
 * ##################################################### End SceneConfigurationPage #####################################################
*//*
 * ##################################################### Start StatusPage Addon #####################################################
 */
StatusPage.prototype.appendDOMFragmentCOInfosTo = function(parentElement) {
  var span = document.createElement('span');
  span.setAttribute('hidden', '');
  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload && mainSite.appState) {
        span.removeAttribute('hidden');
      } else {
        span.setAttribute('hidden', '');
      }
    }
  );
  parentElement.appendChild(span);

  parentElement = span;

  var bridgeLastErrorCO = 3;
  this.appendDOMFragmentKimCoInfoTo(parentElement, bridgeLastErrorCO);

  parentElement.appendChild(document.createElement('br'));

  var bridgeConnectionStateCO = 1;
  this.appendDOMFragmentKimCoInfoTo(parentElement, bridgeConnectionStateCO);

  parentElement.appendChild(document.createElement('br'));

  var thisClass = this;
}

StatusPage.prototype.prepareAppInfo = function(divAppInfomation) {
  headerAppInformation = document.createElement('h3');
  headerAppInformation.setAttribute('class', 'h3');
  headerAppInformation.appendChild(document.createTextNode(i18n.translate('application_information')));
  divAppInfomation.appendChild(headerAppInformation);

  var fragmentAppState = document.createElement('span');
  fragmentAppState.setAttribute('hidden', '');
  divAppInfomation.appendChild(fragmentAppState);
  this.appendDOMFragmentAppStateTo(fragmentAppState);

  var thisClass = this;
  thisClass.dataBindings.push(
    function() {
      if (mainSite.deviceInfo && mainSite.deviceInfo.EtsDownload && mainSite.appState) {
        fragmentAppState.removeAttribute('hidden');
      } else {
        fragmentAppState.setAttribute('hidden', '');
      }
    }
  );

  this.appendDOMFragmentCOInfosTo(divAppInfomation);

  divAppInfomation.appendChild(document.createElement('br'));
}

StatusPage.prototype.updateCO = function(span, textNode, currentCO) {
  switch (currentCO.id) {
    case 1:
      if (currentCO.value == '1') {
        span.setAttribute('class', 'text--success');
        textNode.nodeValue = i18n.translate('connected');
      } else if (currentCO.value == '0') {
        span.setAttribute('class', 'text--error');
        textNode.nodeValue = i18n.translate('disconnected');
      }
      break;
    case 3:
      var error_id = 'last_error_' + currentCO.value;
      if (currentCO.value == '0' || currentCO.value == '') {
        error_id = 'last_error_0';
        span.setAttribute('class', 'text--success');
      } else {
        span.setAttribute('class', 'text--error');
      }
      textNode.nodeValue = i18n.translate(error_id);
      break;
    default:
      break;
  }
}
/*
 * ##################################################### End StatusPage Addon #####################################################
 */
/*
 * lightconfigsocket.js
 * copyright 2013-2017 (c) ise GmbH, Oldenburg, Germany
 */


function CreateWebSocket() {
  var host = window.location.host;
  var uri = GetWebSocketURL(host, 8153);
  return new WebSocket(uri);
}

var LightMappingSocket = function() {
  var socket = function(websocket) {
    this.websocket = websocket;
    this.pendingRequests = [];
    var this_ = this;
    websocket.onmessage = function(event) {
      if (this_.pendingRequests.length === 0) {
        //TODO unexpected message
        return;
      }
      var response = JSON.parse(event.data);
      var responseType = response.response;
      var requestSent = this_.pendingRequests.shift();
      requestSent.callback(response);
    };
    websocket.onerror = function(error) {
      console.log(error);
      if (error.target.readyState == 3) {
        // handled in lamps.js
        //alert("Lost connection to websocket service. Please check the connection and reload this page.");
      }
    }
    websocket.onclose = function(event) {
      // override default handler (shows an alert box)
    }
  }

  socket.prototype.getBridgeAndLightMapping = function(callback) {
    var request = {
      "request": "get_bridge_and_light_mappings"
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "bridge_and_light_mappings",
      callback: callback
    });
  };

  socket.prototype.saveMapping = function(mappings, callback) {
    var request = {
      "request": "save_lightmappings",
      "lightmappings": mappings
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "save_mappings",
      callback: callback
    });
  };


  socket.prototype.getBridgesWithLights = function(callback) {
    var request = {
      "request": "get_bridges_with_lights"
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "get_bridges_with_lights",
      callback: callback
    });
  };

  socket.prototype.invoke_bridge_registration = function(bridge, callback) {
    var request = {
      "request": "invoke_bridge_registration",
      "bridge_ident": bridge.ident
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "invoke_bridge_registration",
      callback: callback
    });
  };

  socket.prototype.invoke_bridge_deregistration = function(bridge, callback) {
    var request = {
      "request": "invoke_bridge_deregistration",
      "bridge_ident": bridge.ident,
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "invoke_bridge_deregistration",
      callback: callback
    });
  };

  socket.prototype.getSceneMappings = function(callback) {
    var request = {
      "request": "get_scenemappings"
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "get_scenemappings",
      callback: callback
    });
  };

  socket.prototype.getHueScenes = function(callback, cached) {
    if (cached === undefined) {
      cached = true;
    }
    var request = {
      "request": "get_hue_scenes",
      "cached": cached
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "get_hue_scenes",
      callback: callback
    });
  };

  socket.prototype.saveScenemapping = function(scene, callback) {
    var request = {
      "request": "save_scenemapping",
      "scene": scene
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "save_scenemapping",
      callback: callback
    });
  };

  socket.prototype.deleteScenemapping = function(number, callback) {
    var request = {
      "request": "delete_scenemapping",
      "number": number
    };
    var requestStr = JSON.stringify(request);
    this.websocket.send(requestStr);
    this.pendingRequests.unshift({
      request: "delete_scenemapping",
      callback: callback
    });
  };

  return socket;
}();
